/* +--------------------------------+
   | ANALITZADOR D'ESPECTRES 'ACME' |
   | OSCILOSCOPI DIGITAL            |
   | Per Antonio J. Anton. 26/8/94  |
   +--------------------------------+ */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <math.h>
#include <dos.h>
#include <graphics.h>

#include "parser.h"

typedef struct
 {
   float re, im;
 } complex;

extern int  FFT(complex x[], unsigned n);

#define pi      3.1415926536
#define FREQ_MIN         100
#define FREQ_MAX      150000
#define POT_MIN            6
#define POT_MAX           12
#define RET_MIN            1
#define RET_MAX           50
#define LLINDAR_MIN     -120
#define LLINDAR_MAX      120
#define MAX_LINEA        256

// enum { FALSE = 0, TRUE };
enum { interpolat, barres, punts };
enum { lineal, logaritmic };
enum { modul, fase, part_real, part_imag };

void *display;
int *entrada;
volatile int is_signal = FALSE;
volatile int overrun = FALSE;
volatile int slope = 0;         /* 0 = ascendent, 1 = descendent */
volatile int trigger = 0;       /* flanc de dispar */
char *finestres[] = { "none", "barlett", "hanning", "hamming", "blackman" };
char *mostrar[] = { "absolute", "argument", "real", "imaginary" };
char *entrades[] = { "none", "LPT1", "SB", "INT 0x81", "EXPR" };
complex *vector;
float   *enfinestrat;
volatile unsigned mostres = 513, potencia = 9, mostres2 = 513;
float factor_finestra = 0.0078740157;
float frequencia = 10.0e3, frequencia2 = 10.0e3;
unsigned mode = modul, plot = interpolat, mode2 = part_real, plot2 = punts,
	 refresh = TRUE, when_refresh = 0, refreshing = 0;
unsigned finestra = 2, tmp2;
volatile unsigned captador = 2;
unsigned ampli_log = TRUE, ampli2_log = FALSE, freq_log = FALSE, temps_log;
float freq_inf = 0, freq_sup = 5.0e3,
      temps_inf = 0, temps_sup = 0.0512,        
      ampli_inf = -10, ampli_sup = 30,
      ampli2_inf = -150, ampli2_sup = 150;
unsigned divisions_freq = 8, divisions_temps = 4, divisions_ampli = 4;
unsigned opcions_extra = 0x0;
int fin = FALSE;
int t, inc, inc2, n1, n2;
float factor1, factor2, tmp;
int fourier = TRUE;
char expresio[MAX_LINEA + 1];
double delta_time, time_pos;
pnode compiled;

#define DEMORA(x)       { long l; for(l = 0; l < (x); l++); }

void carrega_config(void)
{
  FILE *arxiu;

  arxiu = fopen("acme.cfg", "r");
  if(arxiu == NULL)
   return;

  fscanf(arxiu, "%u %u %f %u %u %u", &mostres, &potencia, &frequencia,
	 &mode, &plot, &refresh);
  fscanf(arxiu, "%u %u %u %u %u", &when_refresh, &finestra, &captador,
	 &ampli_log, &freq_log);
  fscanf(arxiu, "%f %f %f %f", &freq_inf, &freq_sup, &ampli_inf, &ampli_sup);
  fscanf(arxiu, "%u %f %u %u", &mostres2, &frequencia2, &mode2, &plot2);
  fscanf(arxiu, "%u %f %f %u %u", &ampli2_log, &ampli2_inf, &ampli2_sup,
	 &inc2, &fourier);
  fscanf(arxiu, "%f %f", &temps_inf, &temps_sup);
  fscanf(arxiu, "%u %u", &slope, &trigger);
  fgets(expresio, 2, arxiu);
  fgets(expresio, MAX_LINEA + 1, arxiu);
  fclose(arxiu);
}

void guarda_config(void)
{
  FILE *arxiu = fopen("acme.cfg", "w");

  fprintf(arxiu, "%u %u %f %u %u %u\n", mostres, potencia, frequencia,
	  mode, plot, refresh);
  fprintf(arxiu, "%u %u %u %u %u\n", when_refresh, finestra, captador,
	  ampli_log, freq_log);
  fprintf(arxiu, "%f %f %f %f\n", freq_inf, freq_sup, ampli_inf, ampli_sup);
  fprintf(arxiu, "%u %f %u %u\n", mostres2, frequencia2, mode2, plot2);
  fprintf(arxiu, "%u %f %f %u %u\n", ampli2_log, ampli2_inf, ampli2_sup,
	  inc2, fourier);
  fprintf(arxiu, "%f %f\n", temps_inf, temps_sup);
  fprintf(arxiu, "%u %u\n", slope, trigger);
  fprintf(arxiu, "%-*s\n", MAX_LINEA, expresio);
  fclose(arxiu);
}

void interrupt (*antiua_int8)();         /* vector d'antiua INT 0x8 */
extern void interrupt capturador(void);  /* capturador en assembler */
// extern void interrupt capturador2(void); /* capturador per l'osciloscopi */

void inicialitza_timer0(float f)
{
  unsigned c;
  c = 1.19318e6 / f;
  disable();
  setvect(8, capturador);
  outportb(0x43, 0x36);         /* TIMER0 ACCESSO LSB, MSB, TERMINAL, BINARIO */
  outportb(0x40, c & 0xff);
  outportb(0x40, c >> 8);
  enable();
}

void inicialitza_captador(void)
{
  struct REGPACK regs;
  unsigned demora = 0;

  switch(captador)
   {
     case 2 : outportb(0x226, 1);       /* entrada Sound Blaster */
	      DEMORA(60000);
	      outportb(0x226, 0);       /* reset del DSP */
	      while((inportb(0x22a) != 0xaa) && ++demora < 100);
	      if(demora == 100)
	       captador = 0;
	      break;
     case 3 : regs.r_ax = 0;            /* entrada INT 81h */
	      regs.r_bx = floor(1.19318e6 / frequencia);
	      regs.r_cx = mostres - 1;
	      intr(0x81, &regs);
	      if(regs.r_ax == 0)
	       captador = 0;
	      break;
     case 4 : time_pos = 0.0;
	      delta_time = 1.0 / frequencia;
	      if(compiled != NULL)
	       lliberar_memoria(compiled);
	      initmygetc(expresio);
	      compiled = expr();
	      if(compiled == NULL)
	       captador = 0;
	      else
	       inicialitza_timer0(18.21594238);
	      break;
     default: break;
   }
}

int matherr(struct exception *a)        /* per no mostrar missatge d'error */
{
   return 1;
}

void clear(int x1, int y1, int x2, int y2)
{
  setfillstyle(EMPTY_FILL, 1);
  bar(x1, y1, x2, y2);
}

#define save_display()    getimage(120, 20, 632, 180, display)
#define restore_display() putimage(120, 20, display, COPY_PUT)

void eixos_movils(void)
{
  int x[2], y[2], e = 0, tecla, acaba = FALSE, n;
  float f[2], p[2], t[2];

  setlinestyle(DASHED_LINE, 0, 1);
  setwritemode(1);
  clear(70, 0, 640, 19);
  x[0] = 376, y[0] = 100;
  x[1] = 120, y[1] = 180;

  do
   {
     for(n = 0; n < 2; n++)
      {
	line(x[n], 20, x[n], 180);
	line(120, y[n], 632, y[n]);
	t[n] = temps_inf + (x[n] - 120.0) * (temps_sup - temps_inf) / 512;
	f[n] = freq_inf + (x[n] - 120.0) * (freq_sup - freq_inf) / 512;
	p[n] = (y[n] - factor2) / factor1;
      }
     gotoxy(15, 1);
     if(fourier)
      printf("freq1=%5.2f freq2=%5.2f diff=%5.2f 1/diff=%2.5g              ",
	     f[0], f[1], f[0] - f[1], 1 / (f[1] - f[0] + 1e-10));
     else
      printf("time1=%2.5g time2=%2.5g diff=%2.5g 1/diff=%5.2f              ",
	     t[0], t[1], t[0] - t[1], 1 / (t[0] - t[1] + 1e-10));
     gotoxy(15, 2);
     printf("peak1=%4.2f peak2=%4.2f diff=%4.2f                ", p[0], p[1], p[0] - p[1]);

     tecla = tolower(getch());
     if(tecla == 0)
      tecla = tolower(getch());
     for(n = 0; n < 2; n++)
      {
	line(x[n], 20, x[n], 180);
	line(120, y[n], 632, y[n]);
      }

     switch(tecla)
      {
	case 107 : x[e] -= (x[e] == 120) ? 0 : 1; break;
	case 109 : x[e] += (x[e] == 632) ? 0 : 1; break;
	case 104 : y[e] -= (y[e] ==  20) ? 0 : 1; break;
	case 112 : y[e] += (y[e] == 180) ? 0 : 1; break;
	case 115 : x[e] -= (x[e] >= 130) ? 10 : 0; break;
	case 116 : x[e] += (x[e] <= 622) ? 10 : 0; break;
	case 141 : y[e] -= (y[e] >=  30) ? 10 : 0; break;
	case 145 : y[e] += (y[e] <= 170) ? 10 : 0; break;
	case 'a' : e = (e == 0) ? 1 : 0; break;
	case 'w' : {
		     char dummy[60];
		     clear(70, 0, 640, 19);
		     gotoxy(15, 1); printf("TEXT=");
		     gets(dummy); fflush(stdin);
		     clear(70, 0, 640, 19);
		     settextjustify(LEFT_TEXT, CENTER_TEXT);
		     outtextxy(x[e], y[e], dummy);
		   }
		   break;
	case 'l' : setlinestyle(SOLID_LINE, 0, 1);
		   line(x[0], y[0], x[1], y[1]);
		   setlinestyle(DASHED_LINE, 0, 1);
		   break;
	case 'q' : acaba = TRUE; break;
      }
   }
  while(!acaba);
  setlinestyle(SOLID_LINE, 0, 1);
  setwritemode(0);
  settextjustify(LEFT_TEXT, TOP_TEXT);
}

void prepara_visualitzacio(void)
{
  float a = frequencia / (mostres - 2.0);

  t = 20 - 160 * ampli_sup / (ampli_inf - ampli_sup);
  if(t < 20) t = 20;
  else if(t > 180) t = 180;
  factor1 = 160 / (ampli_inf - ampli_sup);
  factor2 = 20 - 160 * ampli_sup / (ampli_inf - ampli_sup);

  if(fourier)
   {
     n1 = freq_inf / a + 1;
     n2 = freq_sup / a + 1;
     inc = floor(512.0 / (n2 - n1 + 1));
     freq_inf = a * (n1 - 1);
     freq_sup = a * (n2 - 1);
   }
  else
   {
     n1 = frequencia * temps_inf + 1;
     n2 = frequencia * temps_sup + 1;
     inc = floor(512.0 / (n2 - n1 + 1));
     temps_inf = (n1 - 1.0) / frequencia;
     temps_sup = (n2 - 1.0) / frequencia;
   }
}

void genera_finestra(void)
{
  unsigned n;
  
  for(n = 1; n < mostres; n++)
   {
     switch(finestra)
      {
	case 0 : enfinestrat[n] = 1.0;                  /* dirichlett */
		 break;
	case 1 : if((n - 1) <= (mostres - 1) /2)        /* barlett */
		  enfinestrat[n] = 2.0 * (n - 1) / (mostres - 1);
		 else
		  enfinestrat[n] = 2.0 - 2.0 * (n - 1) / (mostres - 1);
		 break;
	case 2 : enfinestrat[n] = 0.5 -                 /* hanning */
				  0.5 * cos(2 * pi * (n - 1) / (mostres - 1));
		 break;
	case 3 : enfinestrat[n] = 0.54 -                /* hamming */
				  0.46 * cos(2 * pi * (n - 1) / (mostres - 1));
		 break;
	case 4 : enfinestrat[n] = 0.42 -                /* blackman */
				  0.5 * cos(2 * pi * (n - 1) / (mostres - 1)) +
				  0.08 * cos(4 * pi * (n - 1) / (mostres - 1));
		 break;
      }
     enfinestrat[n] *= (captador == 4) ? 1.0 / (mostres - 1.0) : 
					 factor_finestra / (mostres - 1.0);
   }
}

void inicialitza(void)
{
  unsigned c;
  is_signal = TRUE;

  if(entrada != NULL)
   free(entrada);
  if(vector != NULL)
   free(vector);
  if(enfinestrat != NULL)
   free(enfinestrat);

  c = floor(1.19318e6 / frequencia);    /* ajusta la frequencia de mostreig */
  frequencia = 1.19318e6 / c;
  freq_inf = 0.0; temps_inf = 0;
  freq_sup = frequencia / 2.0; temps_sup = 511.0 / frequencia;

  entrada = malloc(mostres * sizeof(int));
  vector  = malloc(mostres * sizeof(complex));
  enfinestrat = malloc(mostres * sizeof(float));
  for(c = 1; c < mostres; c++) entrada[c] = 0;
  genera_finestra();
}

void sel_frequencia(void)
{
  unsigned long f;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272, 57, "Sampling freq.");
  outtextxy(232, 78, "New sampling frequency?");
  rectangle(290, 106, 344, 92);
loop:
  gotoxy(38, 13);
  scanf("%lu", &f); fflush(stdin);
  gotoxy(38, 13); puts("     ");
  if(f < FREQ_MIN || f > FREQ_MAX) goto loop;
  frequencia = f;
  inicialitza();
  prepara_visualitzacio();
}

void sel_mostres(void)
{
  unsigned n;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272, 57, "Mostres de la FFT");
  outtextxy(232, 78, "Mostres = 2**N; N?");
  rectangle(290, 106, 344, 92);
loop:
  gotoxy(38, 13);
  scanf("%u", &n); fflush(stdin);
  gotoxy(38, 13); puts("     ");
  if(n < POT_MIN || n > POT_MAX) goto loop;
  potencia = n;
  mostres = (1 << n) + 1;
  inicialitza();
  prepara_visualitzacio();
}

void sel_senyal(void)
{
  unsigned p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272, 57, "  Input from  ");
  outtextxy(232, 78, "1 - None   2 - LPT1");
  outtextxy(232, 88, "3 - S.B.   4 - INT 0x81");
  outtextxy(232, 98, "5 - Expression gen.");
loop:
  p = getch() - '0';
  if(p < 1 || p > 5) goto loop;
  captador = p - 1;
  if(captador == 4)
   {
     clear(70, 0, 640, 19);
     gotoxy(15, 1);
     printf("x(t)="); gets(expresio);
   }
  is_signal = TRUE;
  inicialitza_captador();
  is_signal = FALSE;
}

void sel_finestra(void)
{
  unsigned p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272,  57, "Select a window");
  outtextxy(232,  78, "1 - Rect. (Dirichlet)");
  outtextxy(232,  86, "2 - Triang. (Barlett)");
  outtextxy(232,  94, "3 - Hanning");
  outtextxy(232, 102, "4 - Hamming");
  outtextxy(232, 110, "5 - Blackman");
loop:
  p = getch() - '0';
  if(p < 1 || p > 5) goto loop;
  finestra = p - 1;
  genera_finestra();
}

void sel_mode(void)
{
  unsigned p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272, 57, "Output signal");
  outtextxy(232, 78, "1 - |X[k]|^2");
  outtextxy(232, 88, "2 - arg{X[k]}");
  outtextxy(232, 98, "3 - Re{X[k]}");
  outtextxy(232,108, "4 - Im{X[k]}");
loop:
  p = getch() - '0';
  if(p < 1 || p > 4) goto loop;
  mode = p - 1;
  switch(mode)
   {
     case modul     : ampli_log = TRUE;
		      break;
     case fase      : ampli_log = FALSE;
		      ampli_inf = -pi;
		      ampli_sup = pi;
		      break;
     case part_real :
     case part_imag : ampli_log = FALSE;
		      break;
   }
  prepara_visualitzacio();
}

void sel_slope(void)
{
  unsigned p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(260,  57, "  Trigger slope  ");
  outtextxy(232,  86, "1 - Positive slope");
  outtextxy(232, 102, "2 - Negative slope");
loop:
  p = getch() - '0';
  if(p < 1 || p > 2) goto loop;
  slope = p - 1;
}

void sel_trigger(void)
{
  unsigned p;
  float f;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(266, 57, "Trigger treshold");
  outtextxy(232, 78, "1 - None");
  outtextxy(232, 98, "2 - User def.");
loop:
  p = getch() - '0';
  if(p < 1 || p > 2) goto loop;
  if(p == 2)
   {
     rectangle(340, 102, 390, 112);
     loopy:
     gotoxy(44, 14); puts("     ");
     gotoxy(44, 14); scanf("%f", &f); fflush(stdin);
     if(f < LLINDAR_MIN || f > LLINDAR_MAX) goto loopy;
   }
  if(p == 0)
   trigger = 0;
  else
   trigger = f;         /* hi ha que arreglar-ho */
}

void sel_plot(void)
{
  unsigned p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(272, 57, "Show signals as");
  outtextxy(232, 78, "1 - Interpolated lines");
  outtextxy(232, 88, "2 - Bars");
  outtextxy(232, 98, "3 - Dots");
loop:
  p = getch() - '0';
  if(p < 1 || p > 3) goto loop;
  plot = p - 1;
}

void sel_refresc(void)
{
  unsigned p, d;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(262, 57, "  Screen update   ");
  outtextxy(232, 78, "1 - Yes");
  outtextxy(232, 88, "2 - No");
  outtextxy(232, 98, "3 - Delayed");
loop:
  p = getch() - '0';
  if(p < 1 || p > 3) goto loop;
  if(p == 3)
   {
     rectangle(330, 102, 370, 112);
     loopy:
     gotoxy(43, 14); puts("    ");
     gotoxy(43, 14); scanf("%u", &d); fflush(stdin);
     if(d < RET_MIN || d > RET_MAX) goto loopy;
   }
  switch(p)
   {
     case 1 : refresh = TRUE; when_refresh = 0; break;
     case 2 : refresh = FALSE; break;
     case 3 : refresh = TRUE; when_refresh = d - 1; break;
   }
  refreshing = 0;
}

void opcions(void)
{
  int p;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(258,  57, "Advanced options");
  outtextxy(232,  78, "0 - None");
  outtextxy(232,  88, "1 - Mean power");
  outtextxy(232,  98, "2 - D.C. component");
  outtextxy(232, 108, "3 - Histogram PDF");
loop:
  p = getch() - '0';
  if(p < 0 || p > 3) goto loop;
  opcions_extra = p;
}

void sel_eixos(int n)
{
  float fmin, fmax, tmin, tmax;
  unsigned la, lf, lt;
  float amin, amax;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(276, 57, "Extrems");
loop:
  switch(n)
   {
     case 0 : gotoxy(30, 11); puts("Fmin?             ");
	      gotoxy(30, 12); puts("Fmax?             ");
	      gotoxy(30, 13); puts("Lineal y/n?       ");
	      gotoxy(36, 11); scanf("%f", &fmin);
	      gotoxy(36, 12); scanf("%f", &fmax);
	      gotoxy(42, 13); lf = tolower(getch()); putchar(lf);
	      fflush(stdin);
	      if(fmin >= fmax || fmin >= frequencia / 2.0 ||
		 fmax > frequencia / 2.0) goto loop;
	      if(lf != 'y' && lf != 'n') goto loop;
	      freq_inf = fmin; freq_sup = fmax;
	      freq_log = (lf == 'n');         
	      break;
     case 1 : gotoxy(30, 11); puts("Amin?             ");
	      gotoxy(30, 12); puts("Amax?             ");
	      gotoxy(30, 13); puts("Lineal y/n?       ");
	      gotoxy(36, 11); scanf("%f", &amin);
	      gotoxy(36, 12); scanf("%f", &amax);
	      gotoxy(42, 13); la = tolower(getch()); putchar(la);
	      fflush(stdin);
	      if(amin >= amax) goto loop;
	      if(la != 'y' && la != 'n') goto loop;
	      ampli_inf = amin; ampli_sup = amax;
	      ampli_log = (la == 'n');
	      break;
     case 2 : gotoxy(30, 11); puts("Tmin?             ");
	      gotoxy(30, 12); puts("Tmax?             ");
	      gotoxy(30, 13); puts("Lineal y/n?       ");
	      gotoxy(36, 11); scanf("%f", &tmin);
	      gotoxy(36, 12); scanf("%f", &tmax);
	      gotoxy(42, 13); lt = tolower(getch()); putchar(lt);
	      fflush(stdin);
	      if(tmin >= tmax || tmin >= 512.0 / frequencia ||
		 tmax > 512.0 / frequencia) goto loop;
	      if(lt != 'y' && lt != 'n') goto loop;
	      temps_inf = tmin; temps_sup = tmax;
	      temps_log = (lt == 'n');
	      break;
   }
  prepara_visualitzacio();
}

void presentacio(void)
{
  unsigned n;

  clear(220, 50, 420, 125);
  rectangle(220, 50, 420, 125);
  line(220, 70, 420, 70);
  outtextxy(276, 57, "A.C.M.E. 1.0");
  outtextxy(230, 74, "Realtime spectrum anal.");
  outtextxy(246, 82, "Digital Oscilloscope");
  outtextxy(242, 96, "By Antonio J. Anton");
  rectangle(280, 106, 360, 118);
  outtextxy(304, 109, " OK ");
  for(n = 0; n < 4000 && !kbhit(); n++);
  if(kbhit()) getch();
}

void pinta_pantalla(void)
{
  int n, m;
  float r;
  char dummy[32];

  cleardevice();
  gotoxy(1, 1);
  if(fourier)
   {
     puts("SWAP\nHELP\n-------\nFREQ.\nSAMP\n-------\nIN FROM\n"
	  "WINDOW\n-------\nMODE\nPLOT\nF AXIS\nY AXIS\nREFRESH\n"
	  "-------\nOPTIONS\nEXPR\nLOCATE\nQUIT");
     gotoxy(11, 1);
     printf("Sampling Frequency %5.2f Hz  Samples %4u  Input comes from %-5s",
	    frequencia, mostres - 1, entrades[captador]);
     gotoxy(11, 2);
     printf("Window is %-8s Displaying %-9s Resolution %3.4f Hz/sam", 
	    finestres[finestra], mostrar[mode], frequencia / (mostres - 1.0));
   }
  else
   {
     puts("SWAP\nHELP\n-------\nIN FROM\nFREQ.\n-------\nT AXIS\nY AXIS\n"
	  "PLOT\nREFRESH\n-------\nSLOPE\nTRIGGER\n"
	  "-------\nOPTIONS\nEXPR\nLOCATE\nQUIT\n");
     gotoxy(11, 1);
     printf("Sampling Frequency %5.2f Hz (Time step %2.4g s)",
	    frequencia, 1.0 / frequencia);
     gotoxy(11, 2);
     printf("Input comes from %-5s", entrades[captador]);
   }
  rectangle(120, 20, 632, 180);
  setlinestyle(USERBIT_LINE, 0x1111, 1);
  settextjustify(RIGHT_TEXT, TOP_TEXT);
  if(fourier)
   {
     r = (freq_sup - freq_inf) / divisions_freq;
     for(m = 0, n = 120; n <= 632; n += 512 / divisions_freq, m++)
      {
	line(n, 20, n, 180);
	sprintf(dummy, "%3.1f\0x0", freq_inf + r * m);
	outtextxy(n, 182, dummy);
      }
   }
  else
   {
     r = (temps_sup - temps_inf) / divisions_temps;
     for(m = 0, n = 120; n <= 632; n+= 512 / divisions_temps, m++)
      {
	line(n, 20, n, 180);
	sprintf(dummy, "%1.5g\0x0", temps_inf + r * m);
	outtextxy(n, 182, dummy);
      }
   }
  r = (ampli_sup - ampli_inf) / divisions_ampli;
  for(m = 0, n =  180; n >= 20; n -= 160 / divisions_ampli, m++)
   {
     line(120, n, 632, n);
     sprintf(dummy, (mode == fase ? "%1.4f\0x0" : "%2.1f%s\0x0"), ampli_inf + r * m,
	     (ampli_log) ? " dB" : "");
     outtextxy(118, n - 6*(m == 0), dummy);
   }
  setlinestyle(SOLID_LINE, 0, 1);
  settextjustify(LEFT_TEXT, TOP_TEXT);
  if(fourier)
   outtextxy(320, 192, "frequency (Hz)");
  else
   outtextxy(336, 192, "time (s)");
  outtextxy(496, 192, "ACME by A.J. Anton");
  save_display();
}

void ajuda(int n)
{
  clear(60, 30, 580, 170);
  rectangle(60, 30, 580, 170);
  outtextxy(164, 35, "A.C.M.E. ANALYZER by Antonio J. Anton");
  line(60, 46, 580, 46);
  switch(n)
   {
     case 0 : outtextxy(70,  80, "SAMP: Changes sample memory (power of 2) that we use when");
	      outtextxy(70,  88, "computing the FFT. The more memory, the better resolution.");
	      outtextxy(70, 104, "WINDOW: Selects a window from None/Barlett/Hanning/Hamming/Kaisser.");
	      outtextxy(70, 112, "MODE: Shows |X[k]|^2, arg{X[k]}, Re{X[k]} or Im{X[k]}");
	      outtextxy(70, 128, "F AXIS/Y AXIS: Changes the axis (freq. or mag.) (lin/log)");
	      break;
     case 1 : outtextxy(70,  80, "SLOPE: Sets the trigger slope (positive/negative).");
	      outtextxy(70,  88, "TRIGGER: Sets the trigger treshold.");
	      outtextxy(70, 128, "T AXIS/Y AXIS: Changes the axis (time or mag.) (lin/log)");
	      break;
   }
  outtextxy(70,  48, "SWAP: Swaps between spectrum/osciloscope.");
  outtextxy(70,  56, "HELP: This poor window help.");
  outtextxy(70,  64, "FREQ: Changes the sampling frecuency. Rembember to use an");
  outtextxy(70,  72, "antialiasing filter if signal is not band limited.");
  outtextxy(70,  96, "IN FROM: Redirects the input from LPT1, Sound Blaster, etc.");
  outtextxy(70, 120, "PLOT: How to plot the FFT (dots, interpolated lines or bars).");
  outtextxy(70, 136, "REFRESH: Selects the persistence of signal on screen.");
  outtextxy(70, 144, "OPTIONS: To compute the PDF, the DC component and mean power.");
  outtextxy(70, 152, "LOCATE: Show varns eixos movils i les seues coordenades.");
  outtextxy(70, 160, "QUIT: Exits to DOS.");
  getch();
}

void calculadora(void)
{
  char llinea[130];
  double r;

  clear(70, 0, 640, 19);
  for(;;)
   {
     clear(70, 0, 640, 7);
     gotoxy(15, 1);
     printf("eval>"); gets(llinea);
     if(strlen(llinea) == 0)
      break;
     r = Evaluar(llinea);
     clear(70, 8, 640, 19);
     gotoxy(15, 2);
     if(IsError())
      printf("last> %s", GetErrorText());
     else
      printf("last> %Lg", (long double) r);
   }
}

void canvia_sistema(void)
{
  fourier = !fourier;
  tmp2 = ampli_log; ampli_log = ampli2_log; ampli2_log = tmp2;
  tmp2 = plot; plot = plot2; plot2 = tmp2;
  tmp = ampli_inf; ampli_inf = ampli2_inf; ampli2_inf = tmp;
  tmp = ampli_sup; ampli_sup = ampli2_sup; ampli2_sup = tmp;
  if(!fourier)
   {
     inc2 = inc; inc = 1;
     mostres2 = mostres; mostres = 513;
     mode2 = mode; mode = part_real;
   }
  else
   {
     inc = inc2;
     mostres = mostres2;
     mode = mode2;
   }
  inicialitza();
  prepara_visualitzacio();
}               

void procesa_tecla(int tecla)
{
  switch(tecla)
   {
     case 'o' : opcions();
		break;
     case 'h' : ajuda(!fourier);
		break;
     case 'q' : fin = TRUE;
		break;
     case 'f' : sel_frequencia();
		break;
     case 's' : if(fourier)
		 sel_mostres();
		else
		 sel_slope();
		break;
     case 'g' : if(!fourier) sel_trigger();
		break;
     case 'i' : sel_senyal();
		break;
     case 'w' : if(fourier) sel_finestra();
		break;
     case 'm' : if(fourier) sel_mode();
		break;
     case 'p' : sel_plot();
		break;
     case 'a' : if(fourier) sel_eixos(0);
		break;
     case 'y' : sel_eixos(1);
		break;
     case 't' : if(!fourier) sel_eixos(2);
		break;
     case 'r' : sel_refresc();
		break;
     case 'l' : eixos_movils();
		break;
     case 'z' : canvia_sistema();
		break;
     case 'e' : calculadora();
		break;
   }
  if(!fin)
   {
     pinta_pantalla();
     if(tecla == 'f' || (tecla == 's' && fourier) || tecla == 'i')
      inicialitza_timer0(frequencia);
   }
}

void captura_senyal(void)
{
  unsigned n;

  if(captador == 4)
   {
     time_pos = 0.0;
     delta_time = 1.0 / frequencia;
     SetVariable("delta_time", delta_time);
     SetVariable("frequency", frequencia);
     SetVariable("samples", mostres - 1);
     SetVariable("center_time", delta_time * 256.0);
     for(n = 1; n < mostres; n++)
      {
	SetVariable("t", time_pos);
	vector[n].re = eval(compiled);
	vector[n].im = 0.0;
	time_pos += delta_time;
      }
   }
  else
   {
     for(n = 1; n < mostres; n++)
      {
	vector[n].re = entrada[n];
	vector[n].im = 0;
      }
   }
}

void enfinestra_senyal(void)
{
  unsigned n;

  for(n = 1; n < mostres; n++)
   vector[n].re *= enfinestrat[n];
}

void visualitza(void)
{
  int n, m, y;
  float r;

  if(overrun)
   {
     overrun = FALSE;
     outtextxy(0, 192, "SYSTEM OVERRUN");
     return;
   }

  if(refresh && when_refresh == refreshing)
   {
     restore_display();
     refreshing = 0;
   }
  else refreshing++;

  if(opcions_extra == 1)
   {
     double potencia = 0.0;
     for(n = 1; n < mostres; n++)
      potencia += pow(vector[n].re, 2) + pow(vector[n].im, 2);
     if(!fourier) potencia /= (double) (mostres - 1);
     gotoxy(1, 25); printf("Power=%4.2e   ", potencia);
   }
  else if(opcions_extra == 2)
   {
     double mitja = 0.0;
     for(n = 1; n < mostres; n++)
      mitja += sqrt(pow(vector[n].re, 2) + pow(vector[n].im, 2));
     mitja /= (mostres - 1);
     gotoxy(1, 25); printf("Mean=%2.4e   ", mitja);
   }

  moveto(120, 160);
  for(m = n1, n = 120; m <= n2; n += inc, m++)
   {
     switch(mode)
      {
	case modul      : r = pow(vector[m].re, 2) + pow(vector[m].im, 2);
			  break;
	case fase       : r = atan2(vector[m].im, vector[m].re);
			  break;
	case part_real  : r = vector[m].re;
			  break;
	case part_imag  : r = vector[m].im;
			  break;
      }
     if(ampli_log) r = (r <= 1.e-100) ? -1000 : 10*log10(r);

     y = factor1 * r + factor2;
     if(y < 20) y = 20;
     else if(y > 180) y = 180;
     switch(plot)
      {
	case interpolat : lineto(n, y); break;
	case barres     : line(n, t, n, y); break;
	case punts      : putpixel(n, y, 1); break;
      }
   }

  if(opcions_extra == 3)
   {
     int b, n;
     double V_inf = 1e9, V_sup = -1e9;

     for(n = 1; n <= 32; entrada[n] = 0.0, n++);
     for(n = 1; n < mostres; n++)
      {
	if(fourier)
	 vector[n].re = sqrt(pow(vector[n].re, 2) + pow(vector[n].im, 2));
	if(V_inf > vector[n].re) V_inf = vector[n].re;
	if(V_sup < vector[n].re) V_sup = vector[n].re;
      }

     for(n = 1; n < mostres; n++)
      {
	b = (int) abs((vector[n].re - V_inf)/(V_sup - V_inf) * 32.0);
	entrada[b]++;
      }

     V_sup = 0.0;
     for(n = 1; n <= 32; n++)
      if(entrada[n] > V_sup) V_sup = entrada[n];

     for(n = 1; n <= 32; n++)
      entrada[n] = 40.0 * entrada[n] / V_sup;

     clear(504, 20, 632, 60);
     rectangle(504, 20, 632, 60);
     for(b = 504, n = 1; n <= 32; n++, b += 4)
      line(b, 60, b, 60 - entrada[n]);
   }
}

void main(void)
{
  int driver = CGA, mode = CGAHI, codi, tecla = 0;

  puts("ACME 1.0. By Antonio J. Anton. Tlf(96)5881219");
  puts("For more info see ACME.DOC");
  initgraph(&driver, &mode, "");
  codi = graphresult();
  if(codi != grOk)
   {
     printf("BGI error: %s\n", grapherrormsg(codi));
     abort();
   }

  display = malloc(imagesize(120, 20, 632, 180));
  cleardevice();
  presentacio();
  carrega_config();
  antiua_int8 = getvect(8);     /* guarda la antigua INT 8 */
  inicialitza();
  inicialitza_captador();
  prepara_visualitzacio();
  pinta_pantalla();
  if(captador != 4) inicialitza_timer0(frequencia);

  is_signal = FALSE;
  fin = FALSE;
  while(!fin)
   {
     if(is_signal || captador == 4)
      {
	captura_senyal();
	if(fourier)
	 {
	   enfinestra_senyal();
	   FFT(vector, potencia);
	 }
	visualitza();
	if(captador != 4) inicialitza_timer0(frequencia);
	is_signal = FALSE;
      }

     if(kbhit())
      {
	tecla = tolower(getch());
	if(tecla) procesa_tecla(tecla);
	tecla = 0;
      }
   }

  is_signal = TRUE;             /* recupera la antiga INT 8 */
  inicialitza_timer0(18.21594238);
  setvect(8, antiua_int8);
  guarda_config();

  free(display);
  free(enfinestrat);
  free(entrada);
  free(vector);

  closegraph();
  puts("ACME 1.0. By Antonio J. Anton. Tlf(96)5881219");
  puts("For more info see ACME.DOC");
}
